<?php
include 'config.php';
$code = $_GET['code'];
$state = $_GET['state'];
$url = $config['access_token_download'];
$post = array(
    'code' => $code,
    'grant_type' => 'authorization_code',
    'client_id' => $config['client_id_download'],
    'client_secret' => $config['client_secret_download'],
    'redirect_uri' => $config['download_redirect_uri'],
);
$vh = curl_init($url);
curl_setopt($vh, CURLOPT_CUSTOMREQUEST, "POST");
curl_setopt($vh, CURLOPT_POST, true);
curl_setopt($vh, CURLOPT_TIMEOUT, 30); //timeout after 30 seconds
curl_setopt($vh, CURLOPT_POSTFIELDS, $post);
curl_setopt($vh, CURLOPT_SSL_VERIFYPEER, 0);
curl_setopt($vh, CURLOPT_SSL_VERIFYHOST, 0);
curl_setopt($vh, CURLOPT_RETURNTRANSFER, true);
$result = curl_exec($vh);
curl_close($vh);
$notgettingdata = explode('', $result);
$getToken = json_decode($notgettingdata[1]);

if (isset($getToken->access_token)) {
    $access_token = $getToken->access_token;
}
if (isset($access_token)) {
    $doc = new DOMDocument('1.0');
    $doc->formatOutput = true;
    $doc = new DOMDocument('1.0');
    $doc->formatOutput = true;
    $root = $doc->createElement('maincontent');
    $root = $doc->appendChild($root);
    $title = $doc->createElement('code');
    $title = $root->appendChild($title);
    $enclosure = $doc->createAttribute('num');
    $enclosure->value = $code;
    $title->appendChild($enclosure);
    $title = $doc->createElement('access_token');
    $title = $root->appendChild($title);
    $text = $doc->createTextNode($access_token);
    $text = $title->appendChild($text);
    $doc->save("xml/hashKey.xml");
}
if (file_exists("xml/hashKey.xml")) {
    $xml = (array) simplexml_load_file("xml/hashKey.xml") or die("Error: Cannot create object");
} else {
    echo "xml/hashKey.xml file doesnot exists";
}
$access_token = $xml['access_token'];

$headers = array(
    'Authorization: Bearer ' . $access_token
        //'Authorization: Basic '. base64_encode("$username:$password")
);
$urlFile = $config['file_uri'];
$vhf = curl_init($urlFile);
curl_setopt($vhf, CURLOPT_TIMEOUT, 30); //timeout after 30 seconds
curl_setopt($vhf, CURLOPT_HTTPHEADER, $headers);
curl_setopt($vhf, CURLOPT_SSL_VERIFYPEER, 0);
curl_setopt($vhf, CURLOPT_SSL_VERIFYHOST, 0);
curl_setopt($vhf, CURLOPT_RETURNTRANSFER, true);
$resFile = curl_exec($vhf);
curl_close($vhf);
$resFileNew = explode('', $resFile);
$uriRes = json_decode($resFileNew[1]);
$uriDir = array();
$uriFiles = array();
foreach ($uriRes->items as $uriI) {
    if ($uriI->type == "dir") {
        $uriDir[] = (array) $uriI;
    } else {
        $uriFiles[] = (array) $uriI;
    }
}
if ($uriDir == NULL || $uriFiles == NULL) {
    $x = array_merge($uriDir, $uriFiles);
    foreach ($x as $y) {
        if ($y != NULL) {
            $uriItems[] = $y;
        }
    }
} else {
    $uriItems = array_merge($uriDir, $uriFiles);
}
$uriItemsArray['items'] = $uriItems;
$dataDirectory['directory'] = $uriRes->directory;
$dataF = array_merge($dataDirectory, $uriItemsArray);

$headers = array(
    'Authorization: Bearer ' . $access_token
        //'Authorization: Basic '. base64_encode("$username:$password")
);
$urlissued = $config['issued_doc_url'];
$vhi = curl_init($urlissued);
curl_setopt($vhi, CURLOPT_TIMEOUT, 30); //timeout after 30 seconds
curl_setopt($vhi, CURLOPT_HTTPHEADER, $headers);
curl_setopt($vhi, CURLOPT_SSL_VERIFYPEER, 0);
curl_setopt($vhi, CURLOPT_SSL_VERIFYHOST, 0);
curl_setopt($vhi, CURLOPT_RETURNTRANSFER, true);
$resissued = curl_exec($vhi);
$resissuedErr = curl_error($vhi);
curl_close($vhi);
$issuedNew = explode('', $resissued);
$dataI = json_decode($issuedNew[1], TRUE);

include 'header.php';
?>
<div class="se-pre-con"></div>
<div id="wrapper">
    <div id="page-wrapper">
        <div class="container-fluid">
            <!-- Page Heading -->
            <div class="row">
                <div class="col-lg-12">
                    <div class="container">
                        <ul class="nav nav-tabs">
                            <li class="active"><a data-toggle="tab" href="#uploadeddocument"><img src="images/uploaded_files.png">Uploaded Document</a></li>
                            <li><a data-toggle="tab" href="#issueddocument" ><img src="images/issuedfile.png">Issued Document</a></li>
                        </ul>
                        <div class="tab-content">
                            <div id="uploadeddocument" class="tab-pane fade in active">
                                <section class="content">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="box box-body" style="min-height: 385px;">
                                                <div class="table-responsive">
                                                    <table class="table">
                                                        <thead style="color:blueviolet;">
                                                            <tr>
                                                                <td>Name</td>
                                                                <td>Size</td>
                                                                <td>Date</td>
                                                                <td id="tdUri" style="display:none;">URI</td>
                                                            </tr>
                                                        <div>
                                                            <span onclick="uriData(null, null)" class="fa fa-home fa-2x" style="color:blueviolet; cursor:pointer; cursor:hand"></span>
                                                            <span id="parent" style="color:blueviolet; font-size: 16px; cursor:pointer; cursor:hand"></span>
                                                        </div>
                                                        </thead>
                                                        <tbody  id="folderPath">
                                                            <?php
                                                            foreach ((array) ($dataF['items']) as $api_detail) {
                                                                if (isset($api_detail['id'])) {
                                                                    $api_detail['id'] = $api_detail['id'];
                                                                    $api_detail['parent'] = $api_detail['parent'];
                                                                } else {
                                                                    $api_detail['id'] = "";
                                                                }
                                                                ?>
                                                                <tr>
                                                                    <?php
                                                                    if (($api_detail['type']) == "dir") {
                                                                        echo '<td onclick="uriData(' . $api_detail['id'] . ',' . $api_detail['parent'] . ')">';
                                                                        echo '<img src="images/folder.svg"></img>';
                                                                        echo($api_detail['name']);
                                                                        echo "</td>";
                                                                    }
                                                                    if ($api_detail['type'] == "file") {
                                                                        echo "<td>";
                                                                        echo '<img src="images/file.svg"></img>';
                                                                        echo($api_detail['name']);
                                                                        echo "</td>";
                                                                    }
                                                                    ?>
                                                                    <td><?php echo($api_detail['size']); ?></td>
                                                                    <td><?php echo($api_detail['date']); ?></td>
                                                                    <?php if ($api_detail['type'] == "file") { ?>
                                                                        <td>
                                                                            <i onclick="download('<?php echo($api_detail['uri'] . ',' . $api_detail['name']); ?>')" class="fa fa-download"> </i>
                                                                        </td>
                                                                    <?php }else{
                                                                        echo "<td></td>";
                                                                    }
                                                                    ?>
                                                                </tr>
                                                            <?php }
                                                            ?>
                                                        </tbody>
                                                    </table>
                                                    <div class="footer">
                                                        <a class="btn btn-default" style="float: right; margin-left: 10px; border-radius:5px;" href="payment.php">Complete Payment</a>
                                                        <a class="btn btn-default" style="float: right; border-radius:5px;" href="index.php">Cancel</a>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>                
                                    </div>
                                </section>
                            </div>
                            <div id="issueddocument" class="tab-pane">
                                <section class="content">
                                    <div class="row">
                                        <div class="col-md-12">
                                            <div class="box box-body" style="min-height: 385px;">
                                                    <table class="table table-responsive">
                                                        <thead style="color:#1569C7">
                                                            <tr>
                                                                <td>Name</td>
                                                                <td>URI</td>
                                                                <td>Created On</td>
                                                            </tr>
                                                        </thead>
                                                        <?php
                                                        foreach ((array) ($dataI['items']) as $issued_detail):
                                                            ?>
                                                            <tr><td>
                                                                    <?php
                                                                    echo '<img src="images/issuedfile.png"></img>';
                                                                    echo($issued_detail['name']);
                                                                    ?>
                                                                </td>
                                                                <td><?php echo($issued_detail['uri']); ?></td>
                                                                <td><?php echo($issued_detail['date']); ?></td>
                                                                <td><?php if ($api_detail['type'] == "file") { ?>
                                                                    <td>
                                                                        <button onclick="download('<?php echo($issued_detail['uri'] . ',' . $issued_detail['name']); ?>')"><i  class="fa fa-download"> </i></button>
                                                                    </td>
                                                                <?php } ?>
                                                            </tr>
                                                            <?php
                                                        endforeach;
                                                        ?>
                                                    </table>
                                                    <div class="footer">
                                                        <a class="btn btn-default" style="float: right; margin-left: 10px; border-radius:5px;" href="payment.php">Complete Payment</a>
                                                        <a class="btn btn-default" style="float: right; border-radius:5px;" href="index.php">Cancel</a>
                                                    </div>
                                            </div>
                                        </div>                
                                    </div>
                                </section>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <!-- /.container-fluid -->
    </div>
</div>
</body>
<?php include 'footer.php' ?>
<script src="js/modernizr.js"></script>
<script>
function uriData(id, parent) {
    $("#folderPath").empty();
    $("#tdUri").show();
    $(".se-pre-con").show();
    var id = id;
    var accessTocken = "<?php echo $access_token; ?>";
    var uri = "<?php echo $api_detail['uri']; ?>";
    var uriDataHtml = "";
    var fileOrFolder = "";
    var onclickFnc = "";
    var dwnldTd = "";
    var accessToken = "<?php echo $access_token; ?>";
    var urifnc = "<?php echo $config['uri_path']; ?>";
    $.post(urifnc, {access_token: accessTocken, id: id}, function (result) {
        $.each(result.items, function (i, l) {
            if (result.items[i].type == "file") {
                console.log(result.items);
                fileOrFolder = '<img src="images/file.svg"></img>';
                onclickFnc = "onclick='thisIsNotAFolder()'";
                dwnldTd = "<td onclick = 'download(\"" + result.items[i].uri + "\",\"" + result.items[i].name + "\");';><button><i  class='fa fa-download'> </i></button></td>";
            } else {
                fileOrFolder = '<img src="images/folder.svg"></img>';
                onclickFnc = "onclick='uriData(" + result.items[i].id + "," + result.items[i].parent + ")'";
                dwnldTd = "<td></td>";
            }
            uriDataHtml += "<tr><td " + onclickFnc + ">" + fileOrFolder + result.items[i].name + "</td><td>" + result.items[i].size + "</td><td>" + result.items[i].date + "</td>\n\
            <td>" + result.items[i].uri + "</td>" + dwnldTd + "</tr>";
            $("#folderPath").html(uriDataHtml);
        });
        $("#parent").html("<span onclick=uriData(" + parent + ",null) >" + result.directory + "</span>");
        $(".se-pre-con").hide();
    }, "json")
            .fail(function () {
                $("#folderPath").html("Some error found");
            });
}
function download(uris, filename) {
    $(".se-pre-con").show();
    var getdata = uris.split(",");
    var uri = getdata[0];
    var filename = getdata[1];
    var accessTocken = "<?php echo $access_token; ?>";
    var dlscfnc = "<?php echo $config['dlsc_path']; ?>"
    var arraydata = {uri: uri, accesstoken: accessTocken, filename: filename}
    $.ajax({
        url: dlscfnc + 'download.php',
        type: 'POST',
        data: arraydata
    }).done(function (response)
    {
        $(".se-pre-con").hide();
        var getdata = JSON.parse(response);
        console.log(getdata[1]);
        window.open("data:" + getdata[0] + ";base64," + getdata[1], '', 'height=650,width=840');
    });
}
$(".se-pre-con").fadeOut("slow");
</script>
</html>